#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Operators;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Optimization;
using System;

namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
  /// <summary>
  /// Represents a symbolic regression solution (model + data) and attributes of the solution like accuracy and complexity
  /// </summary>
  [StorableClass]
  [Item(Name = "SymbolicRegressionSolution", Description = "Represents a symbolic regression solution (model + data) and attributes of the solution like accuracy and complexity.")]
  public class SymbolicRegressionSolution : SymbolicDataAnalysisSolution, IRegressionSolution {
    #region properties
    public new IRegressionModel Model {
      get { throw new NotImplementedException(); }
    }

    public new IRegressionProblemData ProblemData {
      get { throw new NotImplementedException(); }
    }

    public IEnumerable<double> EstimatedValues {
      get { throw new NotImplementedException(); }
    }

    public IEnumerable<double> EstimatedTrainingValues {
      get { throw new NotImplementedException(); }
    }

    public IEnumerable<double> EstimatedTestValues {
      get { throw new NotImplementedException(); }
    }

    public IEnumerable<double> GetEstimatedValues(IEnumerable<int> rows) {
      throw new NotImplementedException();
    }

    #endregion

    [StorableConstructor]
    protected SymbolicRegressionSolution(bool deserializing) : base(deserializing) { }
    protected SymbolicRegressionSolution(SymbolicRegressionSolution original, Cloner cloner)
      : base(original, cloner) {
    }
    public SymbolicRegressionSolution()
      : base() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new SymbolicRegressionSolution(this, cloner);
    }

    protected override void OnModelChanged(EventArgs e) {
      base.OnModelChanged(e);
    }

    protected override void OnProblemDataChanged(EventArgs e) {
      base.OnProblemDataChanged(e);
    }
  }
}
